CEL: Crystal Entity Layer: iBillboardManager Struct Reference (CEL: Crystal Entity Layer Public API Reference)

| ## Public API Reference

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# iBillboardManager Struct Reference

This is a manager to handle billboards. More...

`#include <tools/billboard.h>`

List of all members.

## Public Member Functions
virtual int | BillboardToScreenX (int x) const =0
| Convert a billboard X position to screen space.
virtual int | BillboardToScreenY (int y) const =0
| Convert a billboard Y position to screen space.
virtual iBillboard * | CreateBillboard (const char *name)=0
| Create a new billboard with the given name.
virtual iBillboardLayer * | CreateBillboardLayer (const char *name)=0
| Create a new billboard layer with the given name.
virtual iBillboard * | FindBillboard (const char *name) const =0
| Find a billboard with a given name.
virtual iBillboardLayer * | FindBillboardLayer (const char *name) const =0
| Find a billboard layer with a given name.
virtual iBillboard * | GetBillboard (size_t idx) const =0
| Get a billboard by index.
virtual size_t | GetBillboardCount () const =0
| Get the number of all billboards.
virtual iBillboardLayer * | GetBillboardLayer (size_t idx) const =0
| Get a billboard layer by index.
virtual size_t | GetBillboardLayerCount () const =0
| Get the number of all billboard layers.
virtual void | RemoveAll ()=0
| Remove all billboards.
virtual void | RemoveBillboard (iBillboard *billboard)=0
| Remove a billboard.
virtual void | RemoveBillboardLayer (iBillboardLayer *layer)=0
| Remove a billboard layer.
virtual int | ScreenToBillboardX (int x) const =0
| Convert a screen X position to billboard space.
virtual int | ScreenToBillboardY (int y) const =0
| Convert a screen Y position to billboard space.
virtual void | SetDefaultTextBgColor (const csColor &color)=0
| Setup the default background color to use for text.
virtual void | SetDefaultTextBgTransparent ()=0
| Setup the default text background to use transparency.
virtual void | SetDefaultTextFgColor (const csColor &color)=0
| Setup the default foreground color to use for text.
virtual bool | SetDefaultTextFont (const char *fontname, float fontsize)=0
| Setup the default font to use for text.
virtual void | SetFlags (uint32 flags, uint32 mask)=0
| Set flags for all billboards.
virtual void | StackAfter (iBillboard *bb, iBillboard *other)=0
| Put a billboard after the given other billboard.
virtual void | StackBefore (iBillboard *bb, iBillboard *other)=0
| Put a billboard before the given other billboard.
virtual void | StackBottom (iBillboard *bb)=0
| Bring a billboard to the bottom of the stack.
virtual void | StackDown (iBillboard *bb)=0
| Bring a billboard one closer to the bottom.
virtual void | StackTop (iBillboard *bb)=0
| Bring a billboard to the top of the stack (first visible).
virtual void | StackUp (iBillboard *bb)=0
| Bring a billboard one closer to the top.
virtual bool | TestCollision (iBillboard *bb1, iBillboard *bb2)=0
| Test if two billboards collide with each other and return true if they do.

## Detailed Description

This is a manager to handle billboards.

This is used in combination with the billboard property class.

Definition at line 331 of file billboard.h.

## Member Function Documentation

virtual int iBillboardManager::BillboardToScreenX | ( | int | x | ) | const`[pure virtual]`

| Convert a billboard X position to screen space.

virtual int iBillboardManager::BillboardToScreenY | ( | int | y | ) | const`[pure virtual]`

| Convert a billboard Y position to screen space.

virtual iBillboard* iBillboardManager::CreateBillboard | ( | const char * | name | ) | `[pure virtual]`

| Create a new billboard with the given name. Returns 0 on failure. By default a new billboard will be visible and not movable.

virtual iBillboardLayer* iBillboardManager::CreateBillboardLayer | ( | const char * | name | ) | `[pure virtual]`

| Create a new billboard layer with the given name. Returns 0 on failure. Note that there is always a layer with name 'default' which is used for new billboards.

virtual iBillboard* iBillboardManager::FindBillboard | ( | const char * | name | ) | const`[pure virtual]`

| Find a billboard with a given name.

virtual iBillboardLayer* iBillboardManager::FindBillboardLayer | ( | const char * | name | ) | const`[pure virtual]`

| Find a billboard layer with a given name.

virtual iBillboard* iBillboardManager::GetBillboard | ( | size_t | idx | ) | const`[pure virtual]`

| Get a billboard by index.

virtual size_t iBillboardManager::GetBillboardCount | ( |  | ) | const`[pure virtual]`

| Get the number of all billboards.

virtual iBillboardLayer* iBillboardManager::GetBillboardLayer | ( | size_t | idx | ) | const`[pure virtual]`

| Get a billboard layer by index.

virtual size_t iBillboardManager::GetBillboardLayerCount | ( |  | ) | const`[pure virtual]`

| Get the number of all billboard layers.

virtual void iBillboardManager::RemoveAll | ( |  | ) | `[pure virtual]`

| Remove all billboards.

virtual void iBillboardManager::RemoveBillboard | ( | iBillboard * | billboard | ) | `[pure virtual]`

| Remove a billboard.

virtual void iBillboardManager::RemoveBillboardLayer | ( | iBillboardLayer * | layer | ) | `[pure virtual]`

| Remove a billboard layer. Note that all billboards that use this layer will be put back on the default layer. Also note that you can't remove the default layer.

virtual int iBillboardManager::ScreenToBillboardX | ( | int | x | ) | const`[pure virtual]`

| Convert a screen X position to billboard space.

virtual int iBillboardManager::ScreenToBillboardY | ( | int | y | ) | const`[pure virtual]`

| Convert a screen Y position to billboard space.

virtual void iBillboardManager::SetDefaultTextBgColor | ( | const csColor & | color | ) | `[pure virtual]`

| Setup the default background color to use for text.

virtual void iBillboardManager::SetDefaultTextBgTransparent | ( |  | ) | `[pure virtual]`

| Setup the default text background to use transparency.

virtual void iBillboardManager::SetDefaultTextFgColor | ( | const csColor & | color | ) | `[pure virtual]`

| Setup the default foreground color to use for text.

virtual bool iBillboardManager::SetDefaultTextFont | ( | const char * | fontname,
|  | float | fontsize
| ) | `[pure virtual]`

| Setup the default font to use for text.

virtual void iBillboardManager::SetFlags | ( | uint32 | flags,
|  | uint32 | mask
| ) | `[pure virtual]`

| Set flags for all billboards.

virtual void iBillboardManager::StackAfter | ( | iBillboard * | bb,
|  | iBillboard * | other
| ) | `[pure virtual]`

| Put a billboard after the given other billboard.

virtual void iBillboardManager::StackBefore | ( | iBillboard * | bb,
|  | iBillboard * | other
| ) | `[pure virtual]`

| Put a billboard before the given other billboard.

virtual void iBillboardManager::StackBottom | ( | iBillboard * | bb | ) | `[pure virtual]`

| Bring a billboard to the bottom of the stack.

virtual void iBillboardManager::StackDown | ( | iBillboard * | bb | ) | `[pure virtual]`

| Bring a billboard one closer to the bottom.

virtual void iBillboardManager::StackTop | ( | iBillboard * | bb | ) | `[pure virtual]`

| Bring a billboard to the top of the stack (first visible).

virtual void iBillboardManager::StackUp | ( | iBillboard * | bb | ) | `[pure virtual]`

| Bring a billboard one closer to the top.

virtual bool iBillboardManager::TestCollision | ( | iBillboard * | bb1,
|  | iBillboard * | bb2
| ) | `[pure virtual]`

| Test if two billboards collide with each other and return true if they do.

The documentation for this struct was generated from the following file:

- tools/billboard.h